unit untMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, DFInitLng, DFUseLng;

type
  TfrmMain = class(TForm)
    btnViewListEntry: TButton;
    mnuMain: TMainMenu;
    lbMain: TListBox;
    btnLanguage: TButton;
    miFile: TMenuItem;
    miFileSelectLanguage: TMenuItem;
    miFileDT: TMenuItem;
    miFileExit: TMenuItem;
    miHelp: TMenuItem;
    miHelpInfo: TMenuItem;
    Lng: TDFUseLng;
    procedure miHelpInfoClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure lbMainClick(Sender: TObject);
  private
    { Private-Deklarationen }
    Lan: string; // aktuelle Sprache (Dateiname)
    LanDir: string;
    procedure OnLangChange(Sender: TObject);
  public
    { Public-Deklarationen }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}
                                                                  
uses
  untMessages;

procedure TfrmMain.miHelpInfoClick(Sender: TObject);
begin
  Application.MessageBox(PChar(StrLst[WELCOMEMSG]),
                         PChar(StrLst[MSGBXINFO]),
                         MB_OK or MB_ICONINFORMATION);
end;

procedure TfrmMain.FormShow(Sender: TObject);
var
  MainPath: string;
  mi: TMenuItem;
  vSL: TStringList;
  Idx: Integer;
begin
  MainPath := ExtractFilePath(Application.ExeName);
  if MainPath[Length(MainPath)] = '\' then
    Delete(MainPath, Length(MainPath), 1);

  LanDir := MainPath + '\Sprache';
  Lng.LanguageFilesDirectory := MainPath + '\Sprache';

  Lan := Lng.GetActiveLanguage(HKEY_CURRENT_USER, '\Software\Frischa\Example3\', 'LanFile');
  if Lan <> '' then
  begin
    lng.InitForm(landir + '\' + lan, self);
    lng.FillMsgArray(landir + '\' + lan, StrLst, 6000);
  end;

  vSL := TStringList.Create;
  try
    Lng.GetLanguages(vSL);
    vSL.Sort;
    for Idx := 0 to vSL.Count - 1 do
    begin
      mi := TMenuItem.Create(self);
      mi.Name    := 'XXXXX' + IntToStr(Idx);
      mi.Caption := vSL[Idx];
      mi.OnClick := OnLangChange;
      miFileSelectLanguage.Add(mi);
    end;
    if vSL.Count > 0 then
      miFileSelectLanguage.Enabled := true;
  finally
    vSL.Free;
  end;

  vSL := TStringList.Create;
  try
    Lng.GetLanguages(vSL);
    vSL.Sort;
    lbMain.Items.Assign(vSL);
  finally
    vSL.Free;
  end;
end;

procedure TfrmMain.OnLangChange(Sender: TObject);
begin
  if (Sender as TMenuItem).Caption + '.lng' <> lan then
  begin
    Lan := (Sender as TMenuItem).Caption + '.lng';
    Lng.InitForm(Landir + '\' + Lan, self);
    Lng.FillMsgArray(landir + '\' + lan, StrLst, 6000);
    Lng.SetActiveLanguage(HKEY_CURRENT_USER, '\Software\Frischa\Example3\', 'LanFile', lan);
  end;
end;

procedure TfrmMain.lbMainClick(Sender: TObject);
begin
  if lbMain.ItemIndex <> -1 then
    if lbMain.Items[lbMain.ItemIndex] + '.lng' <> lan then
    begin
      Lan := lbMain.Items[lbMain.ItemIndex] + '.lng';
      Lng.InitForm(Landir + '\' + Lan, self);
      Lng.FillMsgArray(landir + '\' + lan, StrLst, 6000);
      Lng.SetActiveLanguage(HKEY_CURRENT_USER, '\Software\Frischa\Example3\', 'LanFile', lan);
    end;
end;

end.
